import React, { useEffect, useState } from 'react';
import PropTypes from 'prop-types';
import ReactDOM from 'react-dom';

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".styles_backdrop_container__LdCZR {\n  z-index: 1000;\n  position: relative;\n}\n\n.styles_backdrop_content__3TkVa {\n  z-index: 1000;\n  position: fixed;\n  height: 100%;\n  width: 100%;\n  top: 0;\n  left: 0;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n\n.styles_render_on_backdrop__2jw6B {\n  box-shadow: 0 0 10px 10px #ffffff;\n  background: #ffffff;\n}\n\n.styles_backdrop__nv-Pu {\n  background-color: #000000;\n  opacity: 0.7;\n  position: fixed;\n  height: 100%;\n  width: 100%;\n  top: 0;\n  left: 0;\n}\n";
var styles = { "backdrop_container": "styles_backdrop_container__LdCZR", "backdrop_content": "styles_backdrop_content__3TkVa", "render_on_backdrop": "styles_render_on_backdrop__2jw6B", "backdrop": "styles_backdrop__nv-Pu" };
styleInject(css);

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var Backdrop = function Backdrop(_ref) {
  var backdropZIndex = _ref.backdropZIndex,
      backdropOpacity = _ref.backdropOpacity,
      backdropColor = _ref.backdropColor,
      renderOnBackdrop = _ref.renderOnBackdrop;
  return React.createElement(
    "div",
    { className: styles.backdrop_container, style: {} },
    React.createElement(
      "div",
      {
        className: styles.backdrop_content,
        style: _extends({}, backdropZIndex && { "z-index": backdropZIndex })
      },
      renderOnBackdrop && React.createElement(
        "div",
        { className: styles.render_on_backdrop },
        renderOnBackdrop
      )
    ),
    React.createElement("div", {
      className: styles.backdrop,
      style: _extends({}, backdropOpacity && {
        opacity: backdropOpacity
      }, backdropColor && {
        "background-color": backdropColor
      })
    })
  );
};

Backdrop.propTypes = {
  backdropZIndex: PropTypes.string,
  backdropOpacity: PropTypes.number,
  backdropColor: PropTypes.string,
  renderOnBackdrop: PropTypes.node
};

var body = document.body;

var Portal = function (_React$Component) {
  inherits(Portal, _React$Component);

  function Portal(props) {
    classCallCheck(this, Portal);

    var _this = possibleConstructorReturn(this, (Portal.__proto__ || Object.getPrototypeOf(Portal)).call(this, props));

    _this.el = document.createElement("div");
    return _this;
  }

  createClass(Portal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      body.appendChild(this.el);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      ReactDOM.unmountComponentAtNode(this.el);
      body.removeChild(this.el);
    }
  }, {
    key: "render",
    value: function render() {
      return ReactDOM.createPortal(this.props.children, this.el);
    }
  }]);
  return Portal;
}(React.Component);

Portal.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
};

var CreateYOLO = function CreateYOLO() {
  var isShown = false;

  return function (_ref) {
    var children = _ref.children;

    var _useState = useState(false),
        _useState2 = slicedToArray(_useState, 2),
        shouldMount = _useState2[0],
        setShouldMount = _useState2[1];

    useEffect(function () {
      if (!isShown) {
        setShouldMount(true);
        isShown = true;
      }
    }, []);

    useEffect(function () {
      return function () {
        isShown = false;
      };
    });

    return shouldMount && children;
  };
};

var YOLO = CreateYOLO();

YOLO.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
};

var css$1 = ".styles_component__2CYFK {\n  z-index: 1001;\n  position: relative;\n  background-color: white;\n  box-shadow: 0 0 10px 10px #ffffff;\n}\n\n";
var styles$1 = { "component": "styles_component__2CYFK" };
styleInject(css$1);

var Spotlight = function Spotlight(_ref) {
  var isActive = _ref.isActive,
      backdropZIndex = _ref.backdropZIndex,
      backdropOpacity = _ref.backdropOpacity,
      backdropColor = _ref.backdropColor,
      children = _ref.children,
      renderOnBackdrop = _ref.renderOnBackdrop;

  var StyledChildren = function StyledChildren() {
    return React.Children.map(children, function (child) {
      return React.cloneElement(child, {
        className: child.props.className + " " + styles$1.component
      });
    });
  };

  return isActive ? React.createElement(
    React.Fragment,
    null,
    React.createElement(StyledChildren, {
      style: _extends({}, backdropZIndex && { "z-index": (+backdropZIndex + 1).toString() })
    }),
    React.createElement(
      YOLO,
      null,
      React.createElement(
        Portal,
        null,
        React.createElement(Backdrop, {
          backdropZIndex: backdropZIndex,
          backdropOpacity: backdropOpacity,
          backdropColor: backdropColor,
          renderOnBackdrop: renderOnBackdrop
        })
      )
    )
  ) : children;
};

Spotlight.propTypes = {
  isActive: PropTypes.bool,
  backdropZIndex: PropTypes.string,
  backdropOpacity: PropTypes.string,
  backdropColor: PropTypes.string,
  renderOnBackdrop: PropTypes.node,
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
};

export default Spotlight;
//# sourceMappingURL=index.es.js.map
